import requests
import time
from datetime import date
from datetime import timedelta
import pandas as pd
import os.path
import time
import os
import csv
import json
import pyodbc
import metadata_parsing_functions


def download_data(mode, version, n_max_tries, max_time_per_dl, start, stop, dl_root):

    # set up SQL server connection
    server = 'swish5.tern.org.au'
    database = 'your_database_name'
    username = 'raphael_grodofzig'
    password = '215_melange_macrotis@'

    print(pyodbc.drivers())

    # Establishing a connection to the SQL Server
    cnxn = pyodbc.connect('DRIVER={PostgreSQL};SERVER=swish5.tern.org.au;UID=raphael_grodofzig;PWD=215_melange_macrotis@')

    cursor = cnxn.cursor()

    connection.close()


def download_metadata(n_max_tries, max_time_per_dl, version, dl_root, meta_basefile, meta_history, meta_params):

    network = os.path.basename(__file__).split('_downloa')[0]
    identifier = meta_params['identifier']

    url_metadata = 'https://data-donnees.az.ec.gc.ca/api/file?path=/air/monitor/national-air-pollution-surveillance-naps-program/ProgramInformation-InformationProgramme/StationsNAPS-StationsSNPA.csv'
    download_location = dl_root+"/CANADA_NAPS/metadata/{}/network_provided/CANADA_NAPS_META_{}.csv"
    Headers = {'User-Agent': 'Mozilla/5.0 (iPad; CPU OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'}
    r = requests.get(url_metadata, headers=Headers, timeout=max_time_per_dl)
    n_tries = 0
    errcode = 999
    today = date.today()
    
    while (n_tries < n_max_tries) and (errcode != 200):

        if r.status_code == 200:

            with open(download_location.format(version, '_unformatted'), 'wb') as outfile:
                outfile.write(r.content)

            print('Downloaded metadata')
            errcode = r.status_code

        elif r.status_code == 404:
            print("No metadata found, error 404")
            errcode = 200

        else:
            # try again
            print('Response error {}, attempt {}'.format(r.status_code, n_tries))
            errcode = r.status_code
            n_tries += 1
            time.sleep(n_tries ** 2) # wait a lil more every time 

    if n_tries == n_max_tries:
        print('Failed downloading {} {} times in {} seconds, error code {}'.format(url_metadata, n_tries, max_time_per_dl, errcode))
    time.sleep(1)

    # import it as pandas to clean header
    meta_file = pd.read_csv(download_location.format(version, '_unformatted'), header=[4])
    meta_file = meta_file[1 : meta_file.index[meta_file[identifier] == '**********Definitions_Définitions**********'][0]] # cut out french line and bottom
    meta_file.to_csv(download_location.format(version, today.strftime('%Y%m%d')), index=False)
    os.remove(download_location.format(version, '_unformatted'))

    # JSON =====================================================================
    network = os.path.basename(__file__).split('_downloa')[0]
    present_meta_file_id = today.strftime('%Y%m%d')

    metadata_parsing_functions.json_parser(dl_root, network, version, meta_basefile, meta_history, meta_params, present_meta_file_id)

